Quite exciting this computer magic

Friday, February 18, 2005

 

Knapsack problem

The knapsack problem is a problem in combinatorial optimization. It derives its name from the maximization problem of choosing as much as possible essentials that can fit into one bag (of maximum weight) you are going to carry on a trip. A similar problem very often appears in business, combinatorics, complexity theory, cryptography and applied mathematics. Given a set of items, each with a cost and a value, then determine the number of each item to include in a collection so that the total cost is less than some given cost and the total value is as large as possible.

The decision problem form of the knapsack problem is the question "can a value of at least V be achieved without exceeding the cost C?"

The 0/1 knapsack problem restricts the number of each item to zero or one.

The unbounded knapsack problem places no bounds on the number of each item.

Of particular interest is the special case of the problem with these properties:

Notice that in this special case, the problem is equivalent to this: given a set of integers, does any subset of it add up to exactly C? Or, if negative costs are allowed and C is chosen to be zero, the problem is: given a set of integers, does any subset add up to exactly 0? This special case is called the subset sum problem. For some reason, it is traditional in cryptography to say "knapsack problem" when it is actually the "subset sum problem" that is meant.

The knapsack problem is often solved using dynamic programming, though no polynomial-time algorithm is known for the general problem. Both the general knapsack problem and the subset sum problem are NP-hard, and this has led to attempts to use subset sum as the basis for public key cryptography systems, such as Merkle-Hellman. These attempts typically used some group other than the integers. Merkle-Hellman and several similar algorithms were later broken, because the particular subset sum problems they produced were in fact solvable by polynomial-time algorithms.

The decision version of the knapsack problem described above is NP-complete and in fact was one of Karp's 21 NP-complete problems.

Contents

  • 1 Dynamic programming solution
  • 2 Greedy algorithm
  • 3 See also
  • 4 References

Dynamic programming solution

The knapsack problem can be solved in pseudo-polynomial time using dynamic programming. The following depicts a dynamic programming solution for the unbounded knapsack problem.

Let the costs be c1, ..., cn and the corresponding values v1, ..., vn. We wish to maximize total value subject to the constraint that total cost is less than C. Then for each i<C, define A(i) to be the maximum value that can be attained with total cost less than or equal to i. Clearly, A(C) is the solution to the problem.

Define A(i) recursively as follows:

Here the maximum of the empty set is taken to be zero. Tabulating the results from A(0) up through A(C) gives the solution. Since the calculation of each A(i) involves examining n items (all of which have been previously computed), and there are C values of A(i) to calculate, the running time of the dynamic programming solution is thus O(nC).

This does not contradict the fact that the knapsack problem is NP-complete, since C, unlike n, is not polynomial in the length of the input to the problem. The length of the input to the problem is proportional to the number of bits in C, not to C itself.

A similar dynamic programming solution for the 0-1 knapsack problem also runs in pseudo-polynomial time. As above, let the costs be c1, ..., cn and the corresponding values v1, ..., vn. We wish to maximize total value subject to the constraint that total cost is less than C. Define a recursive function, A(i, j) to be the maximum value that can be attained with cost less than or equal to j using items up to i.

We can define A(i,j) recursively as follows:

The solution can then be found by calculating A(n, C). To do this efficiently we can use a table to store previous computations. This solution will therefore runs in O(nC) time and O(nC) space, though with some slight modifications we can reduce the space complexity to O(C).

Greedy algorithm

Martello and Toth (1990) proposed a greedy version of the algorithm to solve the knapsack problem. Their version sorts the essentials in decreasing order and then proceeds to insert them into the sack, starting from the first element (the greatest) until there is no longer space in the sack for more. If k is the maximum possible number of essentials that can fit into the sack, the greedy algorithm is guaranteed to insert at least k/2 of them.

See also

References


Archives

February 2004   May 2004   February 2005   March 2005   July 2005   December 2005   July 2006  

This page is powered by Blogger. Isn't yours?

My Photo
Name: